#include <math.h>

void rot_hyperbolic_radial(float *n_fx,float *n_fy,float d_alpha, float rad_factor, float cx, float cy)
{
  float r2,dx = *n_fx-cx, dy = *n_fy-cy,cosal, sinal;

  r2 = (dx)*(dx)+(dy)*(dy); 
  
  d_alpha*=1/(1+r2*rad_factor);

  cosal = cos(d_alpha) ;
  sinal = sin(d_alpha) ;

  *n_fx = cx + dx * cosal - dy * sinal;
  *n_fy = cy + dx * sinal + dy * cosal;
 
}


void rot_cos_radial( float *n_fx,float *n_fy,float d_alpha, float rad_factor, float cx, float cy)
{
  float r,dx = *n_fx-cx, dy = *n_fy-cy,cosal, sinal;
  r = sqrt(dx*dx+dy*dy); 
	
  d_alpha=d_alpha*cos(r*rad_factor); 

  cosal = cos(d_alpha) ;
  sinal = sin(d_alpha) ;

  *n_fx = cx + dx * cosal - dy * sinal;
  *n_fy = cy + dx * sinal + dy * cosal;
 
}

void homothetie_hyperbolic(float *n_fx,float *n_fy, float rad_factor, float cx, float cy)
{
  float r,dx = *n_fx-cx, dy = *n_fy-cy;
  r = sqrt(dx*dx+dy*dy); 
		
  *n_fx = cx + dx/(1+rad_factor*r);
  *n_fy = cy + dy/(1+rad_factor*r);  
}


void homothetie_cos_radial(float *n_fx,float *n_fy, float rad_factor, float cx, float cy)
{
  float r,cosrad, dx = *n_fx-cx, dy = *n_fy-cy;
  r = sqrt(dx*dx+dy*dy); 
  
  cosrad = cos(r*rad_factor);

  *n_fx = cx + dx*cosrad;
  *n_fy = cy + dy*cosrad;  

}

