/*		JESS v2.0.0 (mouducul)	

         Copyright (c) 2000 by Remi Arquier
 Freely redistributable under the Gnu GPL version 2 or later

                   <arquier@crans.org>
	http://www.crans.org/~arquier/plugin-xmms/
march 19 2001
*/

#include <xmms/plugin.h>
#include <stdlib.h>
#include <unistd.h>
#include <glib.h>
#include <math.h>
#include <SDL.h>

#include "SDL_thread.h"
#include "def.h"
#include "struct.h"
#include "distorsion.h"
#include "detection.h"
#include "draw.h"
#include "misc.h"

void usleep (unsigned long usec); 
int nice(int inc);  
/* void *keybtest (void); */
void *renderer (void);
void jess_init (void);
void jess_init_xmms (void);
void jess_cleanup (void);
static void jess_playback_start (void);
static void jess_playback_stop (void);
static void jess_render_pcm (gint16 data[2][512]);

VisPlugin jess_vp = {
  NULL,
  NULL,
  0,
  "_JESS_v2   (mouducul)",
  2,
  0,
  jess_init_xmms,		/* init */
  jess_cleanup,			/* cleanup */
  NULL,				/* about */
  NULL,				/* configure */
  NULL,	        /* disable_plugin */
  jess_playback_start,		/* playback_start */
  jess_playback_stop,		/* playback_stop */
  jess_render_pcm,		/* render_pcm */
				/* jess_render_freq */ 
  NULL
};

guint *table1, *table2, *table3, *table4, pitch, quit_renderer, resolution_change;
guint8 dim[256], dim2[256], *bits, bpp, *pixel, *buffer;
gint16 data[2][512];
gint resx, resy, xres2, yres2;
SDL_Surface *screen;
SDL_Color colors_orig[256][3], colors_used[256];
struct conteur_struct conteur;
SDL_Thread *render_thread; 
SDL_Thread *keybtest_thread; 
SDL_mutex *mutex_one, *mutex_two;
gint its_first_time/* ,session */;



VisPlugin *
get_vplugin_info (void)
{
  return &jess_vp;
}


void
jess_init_xmms (void)
{
  conteur.burn_mode = 2;
  conteur.draw_mode = 3;
  conteur.blur_mode = 0;
  its_first_time = 1;
  resolution_change = 0;
  resx = RESX;
  resy = RESY;
  printf ("\n\n\n------- JESS First Init ------\n"); 
  printf("\n Create mutex\n");
  mutex_one = SDL_CreateMutex();
  mutex_two = SDL_CreateMutex();
  jess_init();
}

void
jess_init (void)
{

  gint i, j, k, x, y;
  float n_fx, n_fy;
  
 /*  quit_keyb = 0; */
  quit_renderer = 0;

  xres2 = resx/2;
  yres2 = resy/2;
  conteur.fade_on_off = 0;
  conteur.fullscreen = 0;
  conteur.blur_mode = 1;

  /******* ALLOCATION OF TABLES AND BUFFERS *****************/
  table1 = (unsigned int *) malloc (resx * resy * sizeof (int));
  if (!table1)
    {
      printf ("Not enought memory for allocating tables\n");
      exit (1);
    }
  table2 = (unsigned int *) malloc (resx * resy * sizeof (int));
  if (!table2)
    {
      printf ("Not enought memory for allocating tables\n");
      exit (1);
    }
  table3 = (unsigned int *) malloc (resx * resy * sizeof (int));
  if (!table3)
    {
      printf ("Not enought memory for allocating tables\n");
      exit (1);
    }
  table4 = (unsigned int *) malloc (resx * resy * sizeof (int));
  if (!table4)
    {
      printf ("Not enought memory for allocating tables\n");
      exit (1);
    }
  printf ("Tables created\n");

  buffer = (guint8 *) malloc (resx * resy ); 
  if (!buffer)
    {
      printf ("Not enought memory for allocating buffer\n");
      exit (1);
    }

  printf ("Buffers created\n");
  /**********************************************************/

  /******* TABLES COMPUTATION *******************************/
  for (k=1; k<5; k++)
    {
      printf ("Computing table number %i\n", k);
      for (i = 0; i < resy; i++)
	{
	  for (j = 0; j < resx; j++)
	    {
	      n_fx = (float) j - xres2 ;
	      n_fy = (float) i - yres2 ;
	  
	      switch(k)
		{
		case 1:
		  rot_hyperbolic_radial (&n_fx, &n_fy, -PI / 5, 0.001, 0,
					 RESFACTY (50)) ;
		  rot_hyperbolic_radial (&n_fx, &n_fy, PI / 2, 0.004,
					 RESFACTX (200), RESFACTY (-30)) ;
		  rot_hyperbolic_radial (&n_fx, &n_fy, PI / 5, 0.001,
					 RESFACTX (-150), RESFACTY (-30)) ;
		  rot_hyperbolic_radial (&n_fx, &n_fy, PI / 30, 0.0001, 0, 0) ;
		  break;
		case 2:
		  rot_cos_radial(&n_fx,&n_fy, 2*PI/75, 0.01,000,000) ; 
		  break;
		case 3:
		  homothetie_hyperbolic(&n_fx, &n_fy, 0.0005,0,0) ; 
		  break;
		case 4:
		  rot_hyperbolic_radial (&n_fx, &n_fy, PI / 30, 0.00010, 0, 0) ;
		  homothetie_hyperbolic(&n_fx, &n_fy, -0.0002,0,0) ; 
	/* 	  homothetie_cos_radial(&n_fx, &n_fy, 0.01,-10,10) ;  */
		  break;
		}

	      x = (int) (n_fx + xres2);
	      y = (int) (n_fy + yres2);

	      if (x < 0 || x >= resx  || y < 0 || y >= resy )
		{
		  x = 0;
		  y = 0;
		}
	
	      switch(k)
		{
		case 1:
		  table1[i * resx + j] = x + y * resx;
		  break;
		case 2:
		  table2[i * resx + j] = x + y * resx;
		  break;
		case 3:
		  table3[i * resx + j] = x + y * resx;
		  break;
		case 4:
		  table4[i * resx + j] = x + y * resx;
		  break;
		}
	    }
	}
    }
  printf("Table computation Ok\n");
  /*************************************************************/

  /***************** DISPLAY INITIALISATION ******************/
  if (SDL_Init (SDL_INIT_VIDEO) < 0)
    {
      fprintf (stderr, "SDL Init failed : %s\n", SDL_GetError ());
      exit (1);
    }
  printf("SDL init Ok\n");

  screen = SDL_SetVideoMode (resx, resy, BPP, SCREENFLAG);
  if (screen == NULL)
    {
      fprintf (stderr, "Graphic mode is not available: %s\n",
	       SDL_GetError ());
      exit (1);
    }

  printf("SDL Setvideo mode Ok\n");

  SDL_EventState (SDL_ACTIVEEVENT, SDL_IGNORE);
  SDL_EventState (SDL_MOUSEMOTION, SDL_IGNORE);

  printf("SDL Event State Ok\n");
  /***************************************************************/

  /******************* COLOR COMPUTATION  ********************/
/*   for (i = 0; i < 256; i++) */
/*     { */
/*       colors_orig[i][0].r = i; */
/*       colors_orig[i][0].g = (gint) ((float) (i * i * i) / (256 * 256)); */
/*       colors_orig[i][0].b = 0; */
/*     } */
/*   for (i = 0; i < 256; i++) */
/*     { */
/*       colors_orig[i][1].r = (gint) ((float) (i * i * i) / (256 * 256)); */
/*       colors_orig[i][1].g = (gint) ((float) (i * i * i) / (256 * 256)); */
/*       colors_orig[i][1].b = (gint) ((float) (i * i * i) / (256 * 256)); */
/*     } */
/*   for (i = 0; i < 256; i++) */
/*     { */
/*       colors_orig[i][2].r = i / 2; */
/*       colors_orig[i][2].g = i; */
/*       colors_orig[i][2].b = (gint) ((float) (i * i * i) / (256 * 256)); */
/*     } */
  for (i = 0; i < 256; i++)
    {
      colors_used[i].r = i;
      colors_used[i].g = (gint) ((float) (i * i * i) / (256 * 256));
      colors_used[i].b = 0;
    }

  SDL_SetColors (screen, colors_used, 0, 256);
  printf("SDL set color Ok\n");

  /*********** FADING TABLES ************************************/
  for (i = 0; i < 256; i++)
    {
      dim[i] = (gint) ((float) ((i * i) / (256 * 4) * 0.25 + 0.75 * i / 4));
      dim2[i] = (guint8) ((float) i * 0.245);
    }
  /**************************************************************/

  /****************** INDEX *************************************/
  pitch = screen->pitch;
  printf ("Pitch : %i\n", pitch);
  pixel = ((guint8 *) screen->pixels);
  bpp = screen->format->BytesPerPixel;
  printf ("Bytes per pixels: %i\n", bpp);
  srand (343425);
 /*  printf ("Randmax %i\n", RAND_MAX); */
  /**************************************************************/

  if (resolution_change == 0)
    {
      render_thread = SDL_CreateThread ( (void *) renderer, NULL);
      if ( render_thread == NULL) {
	fprintf (stderr, "Pthread_create error for thread renderer\n");
	exit (1);
      }
      printf("Pthread_create renderer passed\n");
    }
 if (its_first_time)
    {
/*      keybtest_thread = SDL_CreateThread ( (void *) keybtest, NULL);
      if ( keybtest_thread == NULL) {
	fprintf (stderr, "Pthread_create error for thread keyb_test\n");
	exit (1);
      }
      printf("Pthread_create keyb_test passed\n");*/
      its_first_time=0;
    }
}


void
jess_cleanup (void)
{
  gint i=0;

  if (resolution_change==0)
    {
      i = 0;
      printf("Send quit information to renderer\n");
      quit_renderer = 1;
      while (quit_renderer)
	{
	  i++;
	  usleep(100000);
	  if (i>10*2)
	    {
	      printf("The renderer dont respond, try to kill it\n");
	      SDL_KillThread(render_thread);
	      quit_renderer = 0;
	    }
	}
      printf("Renderer quitted\n");
  

  printf("Destroy mutex\n");
  SDL_DestroyMutex(mutex_one);
  SDL_DestroyMutex(mutex_two);
    }

  free (table1);
  free (table2);
  free (table3);
  free (table4);
  free (buffer);
  SDL_FreeSurface(screen);
  printf("Buffer freed\n");

  SDL_Quit ();
  printf("SDL Quit\n");
}









static void
jess_playback_start (void)
{
  conteur.courbe = 0;
  conteur.angle = 0;
  conteur.angle2 = 0;
  conteur.k1 = 0;
  conteur.k2 = 0;
  conteur.k3 = 10000;
  conteur.fps_min = 100;
  conteur.fps = 40;
  conteur.hist_index = 0;
  conteur.mix_reprise = 1000;
  conteur.last_flash = 1000;
  conteur.burn_mode = 2;
  conteur.draw_mode = 3;
  conteur.v_angle2 = 1;
  conteur.general = 0;
  conteur.blur_mode = 0;
  conteur.freeze = 0;
  conteur.freeze_mode = 0;
  conteur.ultra_freeze = 0;
}







static void
jess_playback_stop (void)
{
  gint j;

  for (j = 0; j < resy * resx; j++)
    {
      *(pixel + j) = 0;
    }
  if (conteur.fullscreen == 1)
    {
      SDL_WM_ToggleFullScreen (screen);
      conteur.fullscreen = 1 - conteur.fullscreen;
    }
}









static void
jess_render_pcm (gint16 data_tmp[2][512])
{
  SDL_mutexP(mutex_one);
  memcpy (data, data_tmp, sizeof( data ));
  SDL_mutexV(mutex_one); 
}







/*
void *keybtest(void)
{
  
  while (!quit_keyb)
    {   
      SDL_mutexP(mutex_two);
   
      SDL_mutexV(mutex_two);
      usleep(100000);   
    }
  
  quit_keyb = 0;

  return NULL;
}
*/







void *renderer (void)
{
  guint j, bmax, nb_sup_50, *tab1, *tab2, *tab3, *tab4;
  guint8 *pix, *buf;
  gint16 data_tmp[2][512];
  nice (10);
 again:;
  printf("Renderer loop started \n");
  
  while (!quit_renderer)
    {     
    
      if(conteur.ultra_freeze == 1)
	  usleep(1000000);
 

      if(conteur.freeze == 0 && conteur.ultra_freeze == 0)
	{
	  nb_sup_50 = 0;

/* 	  SDL_mutexP(mutex_two);  */

	  conteur.ips++;
	  conteur.k2++;
	  conteur.last_flash++;
	  conteur.general++;
	  conteur.angle++;
	  conteur.v_angle2 = 0.97 * conteur.v_angle2;
	  conteur.angle2 += conteur.v_angle2;

	  ips (); 

/* 	  SDL_mutexV(mutex_two); */

	  SDL_mutexP(mutex_one);/**/
	  memcpy (data_tmp, data, sizeof( data ));
	  SDL_mutexV(mutex_one);/**/

	  SDL_LockSurface(screen);/**/
	  /**************** BUFFER DEFORMATION ****************/
	  tab1 = table1;
	  tab2 = table2;
	  tab3 = table3;
	  tab4 = table4;
	  buf = buffer;
	  bmax = resx * resy + (guint) pixel;
	  switch(conteur.blur_mode)
	    {
	    case 0:
	      memcpy(pixel,buffer,resx*resy);
	      break;
	    case 1:
	      for (pix = pixel; pix < (guint8 *) bmax ; pix++)
		*pix = *(buffer + *(tab1++)) ;
	      break;
	    case 2:
	      for (pix = pixel; pix < (guint8 *) bmax; pix++)
		*pix = *(buffer + *(tab2++)) ;
	      break;
	    case 3:
	      for (pix = pixel; pix < (guint8 *) bmax; pix++)
		*pix = *(buffer + *(tab3++)) ;
	      break;
	    case 4:
	      for (pix = pixel; pix < (guint8 *) bmax; pix++)
		*pix = *(buffer + *(tab4++)) ;
	      break;   
	    default:
	      printf("problem with blur_mode\n");
	    }

	  /******************** BLUR *************************/

	  bmax = resx * (resy-1) + (guint) pixel;
	  for (pix = pixel; pix < (guint8 *) bmax; pix++)
	    {
	      *pix += *(pix+1) + *(pix+resx) + *(pix+resx+1); 
	    }


/* 	  SDL_mutexP(mutex_two); */

	  nb_sup_50 = bruit (data, 50);	/* calcule le nombre de niveau sup a 50 */
	  conteur.history[conteur.hist_index++] = nb_sup_50;

	  switch (niveau_bruit (nb_sup_50)) /*******************************************************************/
	    {
	    case 1: /* bruit calme */
	      if (conteur.courbe <= 255 - 35) /* le bruit calme revient */
		conteur.courbe += 32; /* on fait re-apparaitre la courbe */

	      if (conteur.draw_mode == 0)
		courbes (pixel, data, conteur.courbe);
	      else if (conteur.draw_mode == 1)
		l2_grilles_3d (pixel, data, conteur.angle2 / 200, 0,
			       conteur.angle2 / 30, 200, 130);
	      else if (conteur.draw_mode == 2)
			burn_3d (pixel, data, conteur.angle2 / 400, 0,
				 conteur.angle2 / 60, 200, 130,conteur.burn_mode);
	      else if (conteur.k3 > 700) /* mode 3 */
		burn_3d (pixel, data, conteur.angle / 200, 0,
				conteur.angle / 30, 200, 130,conteur.burn_mode);

	      break;

	    case 2: /* bruit modere */
	      conteur.courbe = 0;
	      if (conteur.draw_mode == 0)
		grille_3d (pixel, data, conteur.angle / 200, 0, conteur.angle / 30,
			   200, -nb_sup_50 + 130);
	      else if (conteur.draw_mode == 1)
		l2_grilles_3d (pixel, data, conteur.angle2 / 200, 0,
			       conteur.angle2 / 30, 200, -nb_sup_50 + 130);
	      else if (conteur.draw_mode == 2)
			burn_3d (pixel, data, conteur.angle2 / 400, 0,
				 conteur.angle2 / 60, 200, 130,conteur.burn_mode);
	      else if (conteur.k3 > 300) /* mode 3*/
		burn_3d (pixel, data, conteur.angle / 200, 0,
				conteur.angle / 30, 200, 130,conteur.burn_mode);
	      break;
	    default:
	    }

	  conteur.k3 += 10;
	  if (conteur.k3 < 300)  /* Ici c'est les boules qui se barrent */
	    burn_3d (pixel, data, conteur.angle2 / 200, 0,
			    conteur.angle2 / 200, 200, -50 + 3 * conteur.k3,conteur.burn_mode);


	  /* REPRISE */

	  if (detection_mode_reprise (nb_sup_50) == 1) /* Ici il y a reprise de la musique */
	    {
	      if (conteur.last_flash > 5 * conteur.fps) /* si y  pas eu de flash depuis longtemps: flash */
		{
		
		  printf("Flash\n");

		  /* FLASH */
		  pix = pixel;
		  for (j = 0; j < resy * resx; j++)
		    {
		      *(pix++) = 250;	/* flash */
		    }
		  /* FIN FLASH*/

		  if (conteur.freeze_mode == 0) /* si c pas freeze_mode on change tout */
		    {
		      conteur.burn_mode = rand()%5;
		       printf("Burn mode mode %i\n",conteur.burn_mode);

		      conteur.draw_mode = rand () % 4;   /* on change de mode de trace */
		      printf("Draw mode %i\n",conteur.draw_mode);

		      /* CHANGEMENT DE MODE BLUR */
		      conteur.blur_mode = rand () % 5 ;   /* on change de mode de blur */
		      if (conteur.blur_mode == 4) /* j veux pas le 4 */
			conteur.blur_mode = rand () % 5 ;
		      if(conteur.draw_mode==2)
			conteur.blur_mode=0;
		      printf("Blur mode %i\n",conteur.blur_mode);
		      /*FIN DE CHANGEMENT DE MODE BLUR */

		      random_palette();  
		    }
		  conteur.last_flash = 0; /* on remet le compteur du flash a zero */
		}


	      else /* il y a eu un flash y a pas longtemps, donc on fait juste des etoiles */
		{

		  if (conteur.draw_mode == 3)
		    conteur.k3 = 0;
		  conteur.k1 += 4;

		  /* CHANGEMENT DE MODE BLUR */
		  if ((conteur.freeze_mode == 0) && (conteur.mix_reprise >5) && (conteur.draw_mode!=2) ) /* si c pas freeze_mode on change tout */
		    {
		      conteur.blur_mode = rand () % 4 ; /* on change de mode de blur (sans le 4) */
		      printf("Blur mode %i\n",conteur.blur_mode);
   
		    }
		  /*FIN DE CHANGEMENT DE MODE BLUR */

		  /* LES ETOILES ROULENT */
		  if (conteur.draw_mode != 2 && conteur.draw_mode != 3)     /* si on est pas en mode 2 (boules)*/
		    sinus_rect (pixel, conteur.k1); /* on affiche les etoiles */
		  conteur.v_angle2 += (rand () % 2 - 0.5) * 2 * 4; 
		}


	      conteur.mix_reprise = 0;
	    }


	  
	  
	  if (conteur.mix_reprise < 2 * conteur.fps)
	    {
/* 	      if (conteur.mix_reprise == 0) */
/* 		color = rand () % 2 + 1; */
/* 	      if (conteur.fade_on_off == 1) */
/* 		mix_palette (color, 0, */
/* 			     transition (conteur.mix_reprise, 2 * conteur.fps, */
/* 					 0)); */
	      conteur.mix_reprise++;
	    }
	    SDL_UnlockSurface(screen);/**/

	/*   SDL_mutexV(mutex_two); */
   
	  /************** COPY TO SCREEN AND FADE ***************/
	  buf = buffer;
	  pix = pixel;
	 
	  if (nb_sup_50 > BRUIT_2)
	    {
	      for (j = 0; j <  resy * resx; j++)
		{	    
		  *(buf++) = dim[*(pix++)];
		}
	    }
	  else
	    {
	      for (j = 0; j <  resy * resx; j++)
		{	  
		  *(buf++) = dim2[*(pix++)];
		}
	    }  
	 

	  /******************************************************/
	}
  /*     SDL_mutexP(mutex_two); */
     SDL_UpdateRect (screen,0,0,resx,resy); /**/
  /*    SDL_mutexV(mutex_two); */

     keyboard ();
    }
  printf("Renderer Ok je quitte\n");
  quit_renderer = 0;

  if(resolution_change == 1)
    {
      jess_cleanup();
      jess_init();
      resolution_change = 0;
      goto again;
    }
 
  return NULL;
}
